(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   CMDasSYS (invokes the NT command processor under SYSTEM account)     ***
 ***   Version [1.6.1]                              {Last mod 2003-10-01}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 Current version: 1.6.1.1

 CMDasSYS:
   Installs as a service and invokes the NT command processor (or other apps).
   Afterwards deletes the service and cleans up.

 revision history:
 1.6.1.1 [2003-10-01]
   - Some cleanup.
 1.6.1.0 [2003-09-30]
   - Code was updated and restructured a bit. Now the CMD.EXE will start inside
     the directory from which CMDasSYS was invoked.
 1.6.0.0 [2001-12-23]
   - Omitted Unicode version.
   - The NT command processor now starts on the desktop CMDasSYS is called from.
   - Added comments to the source of the ANSI version.
   - Added version definitions.

 1.5.2.0 [2001-??-??]
   - Some minor improvements (performance, bug-fixing) and different text
     attributes for the new console (green on black) introduced resource section
     for easier localisation.

 ******************************************************************************)

program CMDasSYS;
uses
  Windows,
  WinSvc;

{$R .\Resources\ico.res}
{$R .\Resources\main.res}
{$INCLUDE .\Includes\Compilerswitches.pas}
{$INCLUDE .\Includes\FormatString.pas}

var
// Global and partly initialised variables
  DefaultCommand: string = 'cmd.exe /X /K mode con cols=80 lines=50 & cls';
  m_hModule: HMODULE = 0;
  s_hss: SERVICE_STATUS_HANDLE = 0;
  s_ss: TServiceStatus;
// dummy window class
  wc: TWndClass = (
    style: 0;
    lpfnWndProc: nil;
    cbClsExtra: 0;
    cbWndExtra: 0;
    hIcon: 0;
    hCursor: 0;
    hbrBackground: 0;
    lpszMenuName: nil;
    lpszClassName: 'CMDasSYS_NonsenseWndClass';
    );
  ste: array[0..1] of TServiceTableEntry;

const
  pszServiceName = 'CMD_AS_SYSTEM';
  IDS_COMMAND = 5;
  IDS_contitle = 6;
  SECURITY_NT_AUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  SECURITY_LOCAL_SYSTEM_RID: DWORD = $00000012;
  SECURITY_BUILTIN_DOMAIN_RID: DWORD = $00000020;
  DOMAIN_ALIAS_RID_ADMINS: DWORD = $00000220;
{$IFNDEF DELPHI4UP}
// In Delphi 3 some constants are not yet available
  SERVICE_QUERY_STATUS = $0004;
  SERVICE_START = $0010;
  SERVICE_WIN32_OWN_PROCESS = $00000010;
  SERVICE_INTERACTIVE_PROCESS = $00000100;
  SERVICE_DEMAND_START = $00000003;
  SERVICE_ERROR_NORMAL = $00000001;
{$ENDIF}

type
  PTOKEN_USER = ^TOKEN_USER;
  TOKEN_USER = packed record
    User: TSIDAndAttributes;
  end;

(******************************************************************************
 The following code is partly provided by Microsoft and by Borland

 BEGIN
 ******************************************************************************)

function IsAdmin: BOOL; stdcall;
var
  hToken: THandle;
  cBytes: DWORD;
  pTkGrp: PTokenGroups;
  pAdmin: PSID;
  iLoopG: Integer;

  function GetAdminSid: PSID; stdcall;
  begin
    Result := nil;
    AllocateAndInitializeSid(
      SECURITY_NT_AUTHORITY,
      2,
      SECURITY_BUILTIN_DOMAIN_RID,
      DOMAIN_ALIAS_RID_ADMINS,
      0, 0, 0, 0, 0, 0,
      Result);
  end;

begin
  Result := False;
  hToken := 0;
  if OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, hToken) then
  try
    cBytes := 0;
    GetTokenInformation(hToken, TokenGroups, nil, 0, cBytes);
{$IFDEF DELPHI4UP}
    pTkGrp := Getmemory(cBytes);
{$ELSE}
    pTkGrp := SysGetmem(cBytes);
{$ENDIF}
    if Assigned(pTkGrp) then
    try
      if GetTokenInformation(hToken, TokenGroups, pTkGrp, cBytes, cBytes) then
      begin
        pAdmin := GetAdminSid;
        if Assigned(pAdmin) then
        try
          for iLoopG := 0 to (pTkGrp^.GroupCount - 1) do
            if EqualSid(pTkGrp^.Groups[iLoopG].Sid, pAdmin) then
            begin
              Result := True;
              Break;
            end;
        finally
          FreeSid(pAdmin);
        end;
      end;
    finally
{$IFDEF DELPHI4UP}
      FreeMemory(pTkGrp);
{$ELSE}
      SysFreeMem(pTkGrp);
{$ENDIF}
    end;
  finally
    CloseHandle(hToken);
  end;
end;

function IsLocalSystem: BOOL; stdcall;
var
  hToken: THandle;
  pTUser: PTOKEN_USER;
  cBytes: DWORD;
  pLocal: PSID;

  function GetLocalSystemSid: PSID; stdcall;
  begin
    Result := nil;
    AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 1, SECURITY_LOCAL_SYSTEM_RID, 0, 0, 0, 0, 0, 0, 0, Result);
  end;

begin
  Result := False;
  hToken := 0;
  if OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, hToken) then
  try
    cBytes := 0;
    GetTokenInformation(hToken, TokenUser, nil, 0, cBytes);
{$IFDEF DELPHI4UP}
    pTUser := GetMemory(cBytes);
{$ELSE}
    pTUser := SysGetMem(cBytes);
{$ENDIF}
    if Assigned(pTUser) then
    try
      if GetTokenInformation(hToken, TokenUser, pTUser, cBytes, cBytes) then
      begin
        pLocal := GetLocalSystemSid;
        if Assigned(pLocal) then
        try
          Result := EqualSid(pLocal, pTUser^.User.Sid);
        finally
          FreeSid(pLocal);
        end;
      end;
    finally
{$IFDEF DELPHI4UP}
      FreeMemory(pTUser);
{$ELSE}
      SysFreeMem(pTUser);
{$ENDIF}
    end;
  finally
    CloseHandle(hToken);
  end;
end;
(******************************************************************************
 END
 ******************************************************************************)

function MyGetUserName: string;
var
  nsize: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
begin
  nSize := MAX_PATH;
  SetLength(Result, nSize);
  ZeroMemory(@Result[1], nSize);
  GetUsername(@Result[1], nSize);
  SetLength(Result, lstrlen(@Result[1]));
end;

function MyGetComputerName: string;
var
  nsize: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
begin
  nSize := MAX_PATH;
  SetLength(Result, nSize);
  ZeroMemory(@Result[1], nSize);
  GetComputerName(@Result[1], nSize);
  SetLength(Result, lstrlen(@Result[1]));
end;

function MyDesktopName:String;
var
  hDesk,
  hWinsta:THandle;
  needed:DWORD;
  WinStaN:String;
begin
// Connect to the desktop (needed on Windows NT 3.51)
  GetDesktopWindow;
// Get user's desktop as handle
  hDesk := GetThreadDesktop(GetCurrentThreadID);
// Get user's window station as handle
  hWinsta := GetProcessWindowStation;
  needed := MAX_PATH;
  SetLength(result, needed);
  SetLength(WinStaN, needed);
// Try getting the name of the desktop
  GetUserObjectInformation(hDesk, UOI_NAME, @result[1], length(result), needed);
  GetUserObjectInformation(hWinsta, UOI_NAME, @WinStaN[1], length(WinStaN), needed);
// Set desktop name as string
  SetLength(result, lstrlen(@result[1]));
  SetLength(WinStaN, lstrlen(@WinStaN[1]));
// Merge the name like "WinSta0\Default"
  result := Format('%s\%s', [WinStaN, result]);
end;

procedure StartAsService(CommandLine: string);
var
  szModuleFileName: array[0..MAX_PATH] of Char;
  hSCM: SC_HANDLE;
  hSvc: SC_HANDLE;
  nRetry: Integer;
  DesktopN: string;
  args: array[0..2] of PChar;
begin
  DesktopN := MyDesktopName;
// Fill buffer with zeroes
  ZeroMemory(@szModuleFileName[0], sizeof(szModuleFileName));
// Get name and path of the module (current app; here: CMDasSYS)
  GetModuleFileName(0, szModuleFileName, MAX_PATH);
// Get handle to SCM
  hSCM := OpenSCManager(nil, SERVICES_ACTIVE_DATABASEW, SC_MANAGER_CREATE_SERVICE);
// Huh ... no handle? So exit ... might be priv not held or sth. Don't care ;)
  if hSCM = 0 then
    Halt(GetLastError);
// 1 trial and 1 retry
  for nRetry := 0 to 1 do
  begin
// Create an entry for our "service"
    hSvc := CreateService(hSCM,
      pszServiceName,
      pszServiceName,
      SERVICE_START or SERVICE_QUERY_STATUS or _DELETE,
      SERVICE_WIN32_OWN_PROCESS,
      SERVICE_DEMAND_START,
      SERVICE_ERROR_NORMAL,
      szModuleFileName,
      nil,
      nil,
      nil,
      nil,
      nil);
// Successful -> out of here ;)
    if hSvc <> 0 then
      Break
    else
      if GetLastError = ERROR_SERVICE_EXISTS then
      begin
// Service exists, hence creation failed - just open it
        hSvc := OpenService(hSCM, pszServiceName, _DELETE);
// Delete it
        DeleteService(hSvc);
        CloseServiceHandle(hSvc);
        hSvc := 0;
// ... and retry ;) ...
      end
      else
// hmmm :-/
        Break;
  end;
// On error quit
  if hSvc = 0 then
    Halt(GetLastError);
// Need a REAL Pchar again ...
  if DesktopN<>'' then
    args[0] := @DesktopN[1]
  else
    args[0] := nil;
// Fill buffer with zeroes
  ZeroMemory(@szModuleFileName[0], sizeof(szModuleFileName));
  GetCurrentDirectory(sizeof(szModuleFileName), @szModuleFileName[0]);
// Second argv is the path from which the EXE was currently started
  args[1] := @szModuleFileName[0];
  if CommandLine <> '' then
    args[2] := @CommandLine[1]
  else
    args[2] := @DefaultCommand[1];
  if not StartService(hSvc, 3, args[0]) then
    Halt(GetLastError);
// After returning delete the service
  DeleteService(hSvc);
// ... and clean up
  CloseServiceHandle(hSvc);
  CloseServiceHandle(hSCM);
end;

procedure HandlerA(fdwControl: DWORD); stdcall;
begin
// Do actually nothing ;)
  SetServiceStatus(s_hss, s_ss);
end;

function MyCreateProcessA(CommandLine, WinStaAndDesktopN, CurrentDir: PChar): BOOL;
//Since invoked from SYSTEM context it creates a process under this context
var
  si: TStartupInfo;
  pi: TProcessInformation;
  Contitle: string;
begin
  result := False;
// Fill startupinfo structure with #0
  ZeroMemory(@si, SizeOf(si));
// Set structure version (i.e. size)
  with si do
  begin
    cb := sizeof(TStartupInfo);
// Set different parameters
    dwFlags := STARTF_USECOUNTCHARS or STARTF_USEFILLATTRIBUTE or STARTF_USEPOSITION;
// Console text attributes
    dwFillAttribute := FOREGROUND_GREEN or FOREGROUND_INTENSITY;
// Console size
    dwXCountChars := 80;
    dwYCountChars := 50;
// If we got a winsta and desktop name set it as startup information
    if WinStaAndDesktopN <> '' then
      lpDesktop := WinStaAndDesktopN;
// Format console title to include user's name
    Contitle := Format('CMD.EXE running as %s@%s\%s', [MyGetUserName, MyGetComputerName, WinStaAndDesktopN]);
// Prepare console title
    si.lpTitle := @Contitle[1];
  end;
// Return the result of creating the process
  if CreateProcess(
    nil,
    CommandLine,
    nil,
    nil,
    True,
    CREATE_NEW_CONSOLE or CREATE_NEW_PROCESS_GROUP,
    nil,
    CurrentDir,
    si,
    pi) then
// If successful just clean up the handles
  begin
// "Detach" from everything
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
    result := True;
  end;
end;

procedure ServiceMainA(argc: DWORD; var argv: array of PChar); stdcall;
begin
// Tell SCM we are running
  s_ss.dwCurrentState := SERVICE_RUNNING;
  s_ss.dwServiceType := SERVICE_WIN32_OWN_PROCESS; // or SERVICE_INTERACTIVE_PROCESS;
// Register control handler -> it handles control codes
  s_hss := RegisterServiceCtrlHandler(pszServiceName, @HandlerA);
// Make our state public
  SetServiceStatus(s_hss, s_ss);

// MyCreateProcess
  MyCreateProcessA(argv[3], argv[1], argv[2]);

// Since we are done tell SCM that we stop
  s_ss.dwCurrentState := SERVICE_STOPPED;
// Make this public
  SetServiceStatus(s_hss, s_ss);
// ... and exit -> at this point we virtually return to our FIRST instance
end;

begin
// Check for Windows 9x or Win 32s and quit if not WinNT
  if GetVersion and $80000000 <> 0 then
    Halt;
// Ensure connection to service window station and desktop (needed on NT 3.51)
// else GetProcessWindowStation would return NULL
  GetDesktopWindow;
// If you want to run this also from non-admin accounts, just comment out the
// following line ;) ... nevertheless the account needs certain privs
// ... so if an admin starts the app
  if IsAdmin then
// Check if also running under SYSTEM account (this is, we run as a service
// or the user invoked the app or a similar one already)
    if IsLocalSystem then
    begin
// SECOND INSTANCE
// Under SYSTEM try to run as a service. This will fail if the app was not
// installed as a service, yet
      ste[0].lpServiceName := pszServiceName;
      ste[0].lpServiceProc := @ServiceMainA;
      ste[1].lpServiceName := nil;
      ste[1].lpServiceProc := nil;
// hand over control to SCM
      StartServiceCtrlDispatcher(ste[0]);
    end
    else
    begin
// FIRST INSTANCE
// Registering a window class will prevent the app from showing a console ->
// since also console apps seem to show a console if no window is presented ->
// at least I recognized this in some cases and this seems to be a workaround
      wc.hInstance := hInstance;
      RegisterClass(wc);
// Invoke another instance of the app as a service
      StartAsService(ParamStr(1));
    end;
end.

